//
//  AppDelegate.m
//  GestureSDK_Demo
//
//  Created by OYXJ on 15/8/8.
//  Copyright (c) 2015年 OYXJ. All rights reserved.
//

#import "AppDelegate.h"

#import "SystemDefine.h"

#pragma mark - 手势
#import "TouchIdUnlock.h"           //指纹解锁
#import "GestureLockScreen.h"       //手势锁屏
#import "GestureTool_Public.h"      //手势工具


#import "ViewController.h"


@interface AppDelegate ()

@end

@implementation AppDelegate

#pragma mark - 自定义

/**
 初始化 主界面
 */
- (void)init_MainUI
{
    ViewController * vc = [[ViewController alloc] init];
    
    UINavigationController * nav = [[UINavigationController alloc] initWithRootViewController: vc];
    
    self.window.rootViewController = nav;
    [self.window makeKeyAndVisible];
    
    [vc release];
    [nav release];
}



#pragma mark - app life cycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    self.window = [[[UIWindow alloc] initWithFrame:UIScreen.mainScreen.bounds] autorelease];
    // Override point for customization after application launch.
    self.window.backgroundColor = UIColor.whiteColor;
    
    /**
     初始化 主界面
     */
    [self init_MainUI];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    
    
    /**
     验证手势密码 －－－ OYXJ on 2015-08-04
     */
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    NSNumber * num = [defaults objectForKey:KEY_UserDefaults_isGestureLockEnabledOrNotByUser];
    BOOL isGestureLockEnabledOrNotByUser = [num boolValue];
    BOOL isHasGestureSavedInNSUserDefaults = [GestureTool_Public isHasGesturePwdStringWhichSavedInNSUserDefaults];
    if (isGestureLockEnabledOrNotByUser &&
        isHasGestureSavedInNSUserDefaults)
    {
        [[GestureLockScreen sharedInstance] showGestureWindowByType: GestureLockScreenTypeGesturePwdVerify];
    }
    
    
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    
    /**
     验证手势密码 －－－ OYXJ on 2015-08-04
     */
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    NSNumber * num = [defaults objectForKey:KEY_UserDefaults_isGestureLockEnabledOrNotByUser];
    BOOL isGestureLockEnabledOrNotByUser = [num boolValue];
    BOOL isHasGestureSavedInNSUserDefaults = [GestureTool_Public isHasGesturePwdStringWhichSavedInNSUserDefaults];
    if (isGestureLockEnabledOrNotByUser &&
        isHasGestureSavedInNSUserDefaults)
    {
        [[GestureLockScreen sharedInstance] showGestureWindowByType: GestureLockScreenTypeGesturePwdVerify];
        
        BOOL canVerifyTouchID = [[TouchIdUnlock sharedInstance] canVerifyTouchID];
        if (canVerifyTouchID) {
            [[TouchIdUnlock sharedInstance] startVerifyTouchID:^{
                [[GestureLockScreen sharedInstance] hide];
            }];
        }
    }
    
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
